#include "main.h"

Screen		scr;		// Telnet virtual screen 80x25
Params		par;        // parsed command-line telnet parameters
CTelnetTCP	tcp;		// Microsoft Win32 TCP/IP protocol

#define	_TcpSend(x) 		tcp.Send(x),scr.Echo(x)
#define CTRL_PRESSED		(LEFT_CTRL_PRESSED|RIGHT_CTRL_PRESSED)

void SendFKey_Normal(WORD);
void SendFKey_Shift(WORD);
void SendFKey_Ctrl(WORD);
void SendFKey_Ctrl_Shift(WORD);

void CTelnetTCP::OnDisconnect() {
	scr.SetCursorPosition(25,0);
	scr.Refresh();
	scr.ColorManage(1); scr.ColorManage(31);
	scr.Puts((BYTE *)"\r\nConnection Closed\r\n");
	scr.Refresh(); Beep(5000,100);
	_exit(0);
}


//
// main() function of console telnet application
//
int main(int argc,unsigned char **argv)
{
 int retv=0;
 OSVERSIONINFO osv;
 osv.dwOSVersionInfoSize=sizeof(osv);

 if (GetVersionEx(&osv)==FALSE) {
	 scr.Puts("ERROR: Can't detrmine your OS Windows version\r\n");
	 scr.Refresh();
	 exit(100);
 } else {
	 if (osv.dwPlatformId==VER_PLATFORM_WIN32s) {
	 scr.Puts("ERROR: Telnet can't work on Win32s, NT or 9x only\r\n");
	 scr.Refresh();
	 exit(100);
	 }
 }


 par.Init(argc,argv);
 if (!par.Host()[0])
   {
	int i;
    scr.Puts("\r\n");
	scr.ColorManage(1); scr.ColorManage(33);
    scr.Puts("ANSI-SCO Console Telnet for Windows NT/9x version 6.0 c  August 1999 \r\n");
	scr.ColorManage(0); scr.ColorManage(32);
	for (i=0; i<79; i++) scr.Puts("\xc4"); scr.Puts("\r\n");
	scr.ColorManage(37);
    scr.Puts("Usage: telnet [-koi] <host> [[<port>]                                \r\n");
    scr.Puts("\r\n");
    scr.Puts("Notes: When runing on Windows NT, uses Windows NT keyboard driver    \r\n");
    scr.Puts("       When runing on Windows 9x, uses MS DOS keyboard driver        \r\n");
    scr.Puts("       Local printing support (PN=\\E[4i:PS=\\E[5i).			       \r\n");
    scr.Puts("New:   Cut & paste operations: <Alt>+<Ins>,<Shift>+<Ins>             \r\n");
	scr.ColorManage(32);
	for (i=0; i<79; i++) scr.Puts("\xc4"); scr.Puts("\r\n");
	scr.ColorManage(36);
    scr.Puts("(C) Arcady V. Pchelinsev, Saratov, Russia, MCP\r\n");
    scr.Puts("    e-mail: arc@pvrr.ru, arc@overta.ru\r\n");
	scr.Puts("    URL:    http://www.pvrr.ru\r\n");
	scr.Puts("    Phone:  7 (845-2) 99-55-88\r\n");
	scr.Refresh();
    retv=1;     // set exit code
   }
 else
   {
	 /*if (!tcp.Connect((LPCSTR)par.Host(),par.Port())) {
		scr.SetCursorPosition(25,0);
		scr.Refresh();
		scr.ColorManage(1); scr.ColorManage(31);
		scr.Puts((BYTE *)"\r\nCan't connect to host\r\n");
		scr.Refresh(); Beep(5000,100);
		_exit(0);
	 } else */{
		char tmp[513]; int i=1;
next:	sprintf(tmp,"Telnet %s - # %d",par.Host(),i);
		if (FindWindow(NULL,tmp)) {
			i++;
			goto next;
		}
		SetConsoleTitle(tmp);
	 }

	DWORD id;
	HANDLE htr=CreateThread(0,0,(LPTHREAD_START_ROUTINE)ProcessNetwork,
                            (LPVOID)0,THREAD_SET_INFORMATION,&id);
 	SetThreadPriority(htr,THREAD_PRIORITY_NORMAL);

	HANDLE ih=GetStdHandle(STD_INPUT_HANDLE);
	SetConsoleMode(ih,0);

	for (;;)
    if (WaitForSingleObject(ih,INFINITE)==WAIT_OBJECT_0) {
	   DWORD dwInput,nEvent;
	   INPUT_RECORD ir;
	   GetNumberOfConsoleInputEvents(scr.hc,&nEvent);
	   for (DWORD i=0; i<nEvent; i++) {
	       ReadConsoleInput(ih,&ir,1,&dwInput);
           if (ir.EventType==KEY_EVENT && ir.Event.KeyEvent.bKeyDown) {
				unsigned long state=ir.Event.KeyEvent.dwControlKeyState;
				if (ir.Event.KeyEvent.uChar.AsciiChar) {
					unsigned char ch=ir.Event.KeyEvent.uChar.AsciiChar;
					if (ch==(BYTE)'\r') 
						tcp.Send("\r\n");
					else {
   						if (ch!=0x3 && osv.dwPlatformId==VER_PLATFORM_WIN32_WINDOWS) ch=getchar();
						if (par.koi8) TransMem(&ch,1,alt2koi);
						_TcpSend(ch);
					}
				} else {
					if (state&CTRL_PRESSED || state&SHIFT_PRESSED) {
						if (state&CTRL_PRESSED && state&SHIFT_PRESSED)
							SendFKey_Ctrl_Shift(ir.Event.KeyEvent.wVirtualKeyCode);
						else {
							if (state&CTRL_PRESSED) SendFKey_Ctrl(ir.Event.KeyEvent.wVirtualKeyCode);
							if (state&SHIFT_PRESSED) {
								if (ir.Event.KeyEvent.wVirtualKeyCode==VK_INSERT) {
									// for paste operation
									char title[513];
									Beep(3000,100);
									GetConsoleTitle(title,512);
									HWND hw=FindWindow(NULL,title);
									HMENU hm=GetSystemMenu(hw,FALSE);
									HMENU hs=GetSubMenu(hm,7);
									UINT msg=GetMenuItemID(hs,2);
									SendMessage(hw,WM_SYSCOMMAND,msg,0);
								} else {
									SendFKey_Shift(ir.Event.KeyEvent.wVirtualKeyCode);
								}
							}
						}
					} else {
						if (state&ALT_PRESSED) {
							if (ir.Event.KeyEvent.wVirtualKeyCode==VK_INSERT) {
								// for mark (cut & paste operation)
								char title[513];
								Beep(3000,100);
								GetConsoleTitle(title,512);
								HWND hw=FindWindow(NULL,title);
								HMENU hm=GetSystemMenu(hw,FALSE);
								HMENU hs=GetSubMenu(hm,7);
								UINT msg=GetMenuItemID(hs,0);
								SendMessage(hw,WM_SYSCOMMAND,msg,0);
							}
						} else SendFKey_Normal(ir.Event.KeyEvent.wVirtualKeyCode);
					}
				}
		   }
	   }
    }

 	if (htr) CloseHandle(htr);

	tcp.Disconnect();
    retv=0;     // set exit code
   }

 return retv;   // return exit code
}


// ---------------------------------------
void SendFKey_Normal(WORD vk)
{
 switch (vk) {
	// function keys
    case VK_F1:  tcp.Send("\x1b[M"); break;
    case VK_F2:  tcp.Send("\x1b[N"); break;
    case VK_F3:  tcp.Send("\x1b[O"); break;
    case VK_F4:  tcp.Send("\x1b[P"); break;
    case VK_F5:  tcp.Send("\x1b[Q"); break;
    case VK_F6:  tcp.Send("\x1b[R"); break;
    case VK_F7:  tcp.Send("\x1b[S"); break;
    case VK_F8:  tcp.Send("\x1b[T"); break;
    case VK_F9:  tcp.Send("\x1b[U"); break;
    case VK_F10: tcp.Send("\x1b[V"); break;
    case VK_F11: tcp.Send("\x1b[W"); break;
    case VK_F12: tcp.Send("\x1b[X"); break;
    // cursor keys
    case VK_UP:   tcp.Send("\x1b[A"); break;
    case VK_DOWN: tcp.Send("\x1b[B"); break;
    case VK_LEFT: tcp.Send("\x1b[D"); break;
    case VK_RIGHT:tcp.Send("\x1b[C"); break;
    // special keys
    case VK_INSERT:  tcp.Send("\x1b[L"); break;
    case VK_DELETE:  tcp.Send("\x7f"); break;
    case VK_HOME:    tcp.Send("\x1b[H"); break;
    case VK_END:     tcp.Send("\x1b[F"); break;
    case VK_PRIOR:   tcp.Send("\x1b[I"); break;
    case VK_NEXT:    tcp.Send("\x1b[G"); break;
    case VK_NUMPAD5: tcp.Send("\x1b[E"); break;
	default: ;
 }
}

// ---------------------------------------
void SendFKey_Shift(WORD vk)
{
	switch (vk) {
		// function keys
		case VK_F1:  tcp.Send("\x1b[Y"); break;
		case VK_F2:  tcp.Send("\x1b[Z"); break;
		case VK_F3:  tcp.Send("\x1b[a"); break;
		case VK_F4:  tcp.Send("\x1b[b"); break;
		case VK_F5:  tcp.Send("\x1b[c"); break;
		case VK_F6:  tcp.Send("\x1b[d"); break;
		case VK_F7:  tcp.Send("\x1b[e"); break;
		case VK_F8:  tcp.Send("\x1b[f"); break;
		case VK_F9:  tcp.Send("\x1b[g"); break;
		case VK_F10: tcp.Send("\x1b[h"); break;
		case VK_F11: tcp.Send("\x1b[i"); break;
		case VK_F12: tcp.Send("\x1b[j"); break;
		default: ;
	}
}

// ---------------------------------------
void SendFKey_Ctrl(WORD vk)
{
	switch (vk) {
		// function keys
		case VK_F1:  tcp.Send("\x1b[k"); break;
		case VK_F2:  tcp.Send("\x1b[l"); break;
		case VK_F3:  tcp.Send("\x1b[m"); break;
		case VK_F4:  tcp.Send("\x1b[n"); break;
		case VK_F5:  tcp.Send("\x1b[o"); break;
		case VK_F6:  tcp.Send("\x1b[p"); break;
		case VK_F7:  tcp.Send("\x1b[q"); break;
		case VK_F8:  tcp.Send("\x1b[r"); break;
		case VK_F9:  tcp.Send("\x1b[s"); break;
		case VK_F10: tcp.Send("\x1b[t"); break;
		case VK_F11: tcp.Send("\x1b[u"); break;
		case VK_F12: tcp.Send("\x1b[v"); break;
		default: ;
	}
}

// ---------------------------------------
void SendFKey_Ctrl_Shift(WORD vk)
{
	switch (vk) {
		// function keys
        case VK_F1:  tcp.Send("\x1b[w"); break;
        case VK_F2:  tcp.Send("\x1b[x"); break;
        case VK_F3:  tcp.Send("\x1b[y"); break;
        case VK_F4:  tcp.Send("\x1b[z"); break;
        case VK_F5:  tcp.Send("\x1b[@"); break;
        case VK_F6:  tcp.Send("\x1b[["); break;
        case VK_F7:  tcp.Send("\x1b[\\"); break;
        case VK_F8:  tcp.Send("\x1b[]"); break;
        case VK_F9:  tcp.Send("\x1b[^"); break;
        case VK_F10: tcp.Send("\x1b[_"); break;
        case VK_F11: tcp.Send("\x1b[`"); break;
        case VK_F12: tcp.Send("\x1b[{"); break;
		default: ;
	}
}
